<?php
/*
Plugin Name: Quick SMS
PLugin URI: http://www.mutube.com/projects/wordpress/quick-sms/
Description: Allows your visitors to SMS messages direct to your mobile phone via email gateways. Many networks & countries now supported, see configuration panel for full list.
Author: Martin Fitzpatrick
Version: 2.9
Author URI: http://www.mutube.com
*/

/*  Copyright 2006  MARTIN FITZPATRICK  (email : martin.fitzpatrick@mutube.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

function quicksms(){
			// Each widget can store its own options. We keep strings here.
		$options = get_option('widget_quicksms');
		if ( !is_array($options) )
		{
			$options = array(
                                'title'=>'Quick SMS',
                           );
		}

			/* If widget is public, or member is logged in */
			if( ($options['permissions']=='public') || ( is_user_logged_in()  ) )
			{


               	//Someone is sending an SMS
                if ( $_POST['quicksms-submit']=='sendsms' ) {
		
			// $options['provider'] contains the whole provider string, split to format/server
			$provider_data=explode("@",$options['provider']);
			// replace n in format string with number, stripping initial 0 (provided in format)
			$provider_data[0]=str_replace('n',ltrim($options['mobile'],0),$provider_data[0]);

	                $to=$provider_data[0] . '@' . $provider_data[1];

			$header=$options['header'];
			$header = str_replace("%blogname%", get_settings('blogname'), $header);

			get_currentuserinfo();
			$header = str_replace("%member%", $user_login, $header);
			$header = str_replace("%date%", date('l dS F Y h:i:s A'), $header);
			

                   	$subject="";
                   	$message=$header . strip_tags(stripslashes($_POST['quicksms-message']));
			$message=substr($message,0,$options['maxlength']);  //Trim message to max SMS number

                   	@mail($to, "", $message, $headers);

		?><div style="font-weight:bold;"><p>Thankyou, your SMS has been sent.</p>
		<p><small>Powered by <a href="http://www.mutube.com/projects/wordpress/quick-sms/?utm_source=quick-sms&utm_medium=plugin">Quick SMS</a></small></p></div><?php
               	} else {
               ?><div style="text-align:right;"><form id="quicksms" method="post" action=""><input name="quicksms-message" size="20"/><input type="hidden" id="quicksms-submit" name="quicksms-submit" value="sendsms"/><input value="Send SMS" name="submit" type="submit"/></form>
	<p style="text-align:right"><small>Powered by <a href="http://www.mutube.com/projects/wordpress/quick-sms/?utm_source=plugin&utm_medium=sidebar">Quick SMS</a></small></p>
			</div><?php
		}

	}

}



// Put functions into one big function we'll call at the plugins_loaded
// action. This ensures that all required plugin functions are defined.
function quicksms_init() {


		// Admin panel widget configuration
		function quicksms_control_form() {

			//Open data files of all networks - parse using PHP format
			$ini_array = parse_ini_file(dirname(__FILE__) . "/mobile-networks.ini", true);
		
			// Get our options and see if we're handling a form submission.
			$options = get_option('widget_quicksms');
			if ( !is_array($options) )
			{
				$options = array(
                                 'title'=>'Quick SMS',
                                 'provider'=>'teleflip.com',
				 'header'=>'%blogname%',
				 'maxlength'=>160
	                           );
			}

			if ( 	( $_POST['quicksms-submit']=='options' ) && 
				( is_numeric($_POST['quicksms-maxlength'])) )
			{

				// Remember to sanitize and format use input appropriately.
				$options['title'] = strip_tags(stripslashes($_POST['quicksms-title']));
				$options['provider'] = strip_tags(stripslashes($_POST['quicksms-provider']));
				$options['mobile'] = strip_tags(stripslashes($_POST['quicksms-mobile']));
				$options['permissions'] = strip_tags(stripslashes($_POST['quicksms-permissions']));
				$options['header'] = strip_tags(stripslashes($_POST['quicksms-header']));
				$options['maxlength'] = strip_tags(stripslashes($_POST['quicksms-maxlength']));

				update_option('widget_quicksms', $options);
			}

			// Be sure you format your options to be valid HTML attributes.
			$title = htmlspecialchars($options['title'], ENT_QUOTES);
			$provider = htmlspecialchars($options['provider'], ENT_QUOTES);
			$mobile = htmlspecialchars($options['mobile'], ENT_QUOTES);

			$header = htmlspecialchars($options['header'], ENT_QUOTES);
			$maxlength = intval($options['maxlength']);
			if($maxlength<=50){$maxlength=50;} else if($maxlength>8000){$maxlength=8000;}


			// Here is our little form segment. Notice that we don't need a
			// complete form. This will be embedded into the existing form.

		?>
		<h4>Widget Settings</h4>
		<table>
		<tr><td><label for="quicksms-title">Title:</label></td><td><input style="width: 200px;" id="quicksms-title" name="quicksms-title" type="text" value="<?php echo $title;?>" /></td></tr>
        <tr><td><label for="quicksms-provider">Provider:</label></td><td>
		<select style="width: 200px;" id="quicksms-provider" name="quicksms-provider" title="Hover mouse over your network for activation instructions.">
                <?php
			foreach($ini_array as $country => $networks)
	                {
				echo '<option value="-" style="font-weight:bold;">' . $country . '</option>'; 

				foreach($networks as $provider_name => $provider_detail)
				{

					$provider_name=substr($provider_name,strpos($provider_name," "));
					$provider_data=explode(":",$provider_detail);

	                      		echo '<option value="' . $provider_data[0] . '"';
	                      		if(strlen($provider_data[0])==2){echo ' style="font-weight:bold;" ';}
	                      		else if($provider_data[0]==$provider){echo ' selected="selected" ';}
	                      		echo ' title="' . $provider_data[1] .'">&nbsp;&nbsp;' . $provider_name . '</option>';
				}
	                }

                ?>
                </select></td></tr>
		<tr><td><label for="quicksms-mobile">Mobile:</label></td><td><input style="width: 200px;" id="quicksms-mobile" name="quicksms-mobile" type="text" value="<?php echo $mobile;?>" title="Enter your mobile number WITHOUT country code."/></td></tr>
		<tr><td><label for="quicksms-maxlength">Access:</label></td><td>
		<select name="quicksms-permissions">
		<option value="members" <?php if($options['permissions']=='members'){echo "selected";} ?>>Members</a>
		<option value="public" <?php if($options['permissions']=='public'){echo "selected";} ?>>Public</a>
		</select></td></tr>
		</table>

		<h4>Message Settings</h4>
		<table>
		<tr><td><label for="quicksms-header">Send:</label></td><td><input style="width: 200px;" id="quicksms-header" name="quicksms-header" type="text" value="<?php echo $header;?>" title="Enter %blogname% %member% %date% or any other text to be sent before your message."/></td></tr>
		<tr><td><label for="quicksms-maxlength">Max SMS Chars:</label></td><td><input style="width: 30px;" id="quicksms-maxlength" name="quicksms-maxlength" type="text" value="<?php echo $maxlength;?>" title="Enter Max number of chars allowed in SMS messages (trims to fit)."/></td></tr>
		</table>

		<input type="hidden" id="quicksms-submit" name="quicksms-submit" value="options" />
                <?php
		}


/*

           SWITCH: IS THE WIDGET PLUGIN LOADED?
           If it is, then we use the widget system for admin. If it isn't we use the old-style.
           Note, the "standard" output method is available regardless of where you're editing
           the admin options.

*/

	if (function_exists('register_sidebar_widget') )
	{   //Do Widget-specific code


		// This is the function that outputs quicksms writing-box
		function widget_quicksms($args) {

			// $args is an array of strings that help widgets to conform to	
			// the active theme: before_widget, before_title, after_widget,
			// and after_title are the array keys. Default tags: li and h2.
			extract($args);
			$options = get_option('widget_quicksms');
			
			/* If widget is public, or member is logged in */
			if( ($options['permissions']=='public') || ( is_user_logged_in()  ) )
			{
				echo $before_widget . $before_title . $options['title'] . $after_title;
				quicksms();
				echo $after_widget;
			}
		}


	    function widget_quicksms_control() {
                     //pass-thru (no extras required)
                     quicksms_control_form();
            }


		// This registers our widget so it appears with the other available
		// widgets and can be dragged and dropped into any active sidebars.
		register_sidebar_widget('Quick SMS', 'widget_quicksms');

		// This registers our optional widget control form. Because of this
		// our widget will have a button that reveals a 300x100 pixel form.
		register_widget_control('Quick SMS', 'widget_quicksms_control', 300, 320);


	} else {

/*

        NO WIDGETS
        We've not found the widgets plugin, so we're going to have to display an admin
        panel for all our options.im

*/

	        function quicksms_control()
	        {
        ?><div class="wrap">
         <h2>QuickSMS Options</h2>
         <div style="width:550px;margin-top:20px;">
         <form action="" method="post">
          <?php
	               quicksms_control_form();
         ?>
         <p class="submit"><input type="submit" value="Save changes &raquo;"></p>
         </form></div>
	</div><?php

	        }

	        function quicksms_add_pages()
	        {
		         add_options_page("Quick SMS Options", "Quick SMS", 10, "quick-sms", quicksms_control);
	        }

        	add_action('admin_menu', 'quicksms_add_pages');


	}

}

// Run our code later in case this loads prior to any required plugins.
add_action('plugins_loaded', 'quicksms_init');

?>
